

/***************************************************/
/***************************************************/
/*****                                         *****/
/*****        Logiciel  infodates version V2   *****/
/*****                                         *****/
/*****      fichier source en langage c        *****/
/*****   Auteur Cruptos (association ACrypTA)  *****/
/*****   date : 15/05/2021                     *****/
/*****                                         *****/
/***************************************************/
/***************************************************/
/*modifié le 15/05/2021 pour détecter les lignes vides*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
int main(int argc, char *argv[])


{
    FILE* f=NULL;    
    char* nom1;
    char tampon[20]="";
    int nbl=0;
    char jourGreg[5]=""; 
    char moisGreg[5]="";
    char anGreg[5]="";
    int jg;
    int mg;
    int ag;
    char result[15];
    int err;
    int Amax;
    int Amin;
    int dates[1000];
    int i;
    int AbsMin;
    
    AbsMin=1200;
    Amax=0;
    Amin=10000;
    
    nom1=argv[1];
    for (i=0; i<1000; i++)
    {
      dates[i]=0;
    }
    if ((f=fopen(nom1,"r"))== NULL)
    {
    printf("Le fichier source est inexistant\n");
    return 2;
    }
    while ( fgets ( tampon, 15, f ) != NULL )
    {
    err=0;
    nbl=nbl+1;
    if (strlen(tampon)>11)
      {
      printf("format date errone ligne %d\n",nbl);
      err=1;
      }
    if (strlen(tampon)<2)
      {
      printf("ligne vide %d\n",nbl);
      err=1;
      }
    if (err==0)
    {
     jourGreg[0]=tampon[0];
     jourGreg[1]=tampon[1];
     jourGreg[2]='\0';
     jg=atoi(jourGreg);
     
     if (tampon[2] !='/')
     {
         printf("erreur de format ligne %d\n",nbl);
         err=1;
     }
    }
    if (err==0)
    {
     moisGreg[0]=tampon[3];
     moisGreg[1]=tampon[4];
     moisGreg[2]='\0';
     mg=atoi(moisGreg);
     
     if (tampon[5]!='/')
     {
         printf("erreur de format ligne %d\n",nbl);
         err=1;
     }
    }
    if (err==0)
    {
     anGreg[0]=tampon[6];
     anGreg[1]=tampon[7];
     anGreg[2]=tampon[8];
     anGreg[3]=tampon[9];
     anGreg[4]='\0';
     ag=atoi(anGreg);
     dates[ag-AbsMin]=1;
     
     if (ag==0)
     {
        printf("annee mal ecrite ligne %d\n",nbl);
        err=1;
     }
    }
    if (err==0)
    {
     if ((mg<1) || (mg>12))
     {
        printf("mois hors limites %d\n",nbl);
        err=1; 
     }
    }
    if (err==0)
    {
     if ((ag%4==0) && ((ag%100!=0)||(ag%400==0)) && (mg==2))
     {
        if ((jg<1) || (jg >29))
        {
            printf("Jour hors limites ligne %d\n",nbl);
            err=1;
        }
     }
     else if ((mg==1) || (mg==3) || (mg==5) || (mg==7) || (mg==8) || (mg==10) || (mg==12))
     {
        if ((jg<1) || (jg >31))
        {
          printf("Jour hors limites ligne %d\n",nbl);
          err=1;
        }
     }
     else if (mg==2)
     {
        if ((jg<1) || (jg >28))
        {
          printf("Jour hors limites ligne %d\n",nbl);
          err=1;
        }
     }
     else
     {
        if ((jg<1) || (jg >30))
        {
          printf("Jour hors limites ligne %d\n",nbl);
          err=1;
        }   
     }
    } 
    if (ag>Amax)
    {
      Amax=ag;
    }
    if (ag<Amin)
    {
    Amin=ag;
    }
  }
  
  fclose(f);
  for (i=Amin-AbsMin;i < Amax-AbsMin+1; i++)
  {
    if (dates[i]==0)
    {
      printf("année manquante %d\n", i+AbsMin);
    }
  }
  printf("année Max %d\n",Amax);
  printf("année Min %d\n",Amin);
  printf("fini \n");

}

