

/***************************************************/
/***************************************************/
/*****                                         *****/
/*****     Logiciel  convR2G version V2.3      *****/
/*****                                         *****/
/*****      fichier source en langage c        *****/
/*****       Auteur Robert Rolland             *****/
/*****        (association ACrypTA)            *****/
/*****   date : 12/05/2022                     *****/
/*****                                         *****/
/***************************************************/
/***************************************************/
/*fichier modifié pour prendre en compte les lignes vides*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void traduc(char * Result, int Jr, int Mr, int Ar,int nbl)
{
    int Jg=0;
    int Mg=0;
    int Ag=0;
    int Jgt=0;
    int Mgt=0;
    int Agt=0;
    
    char obl[3]="/";
    char zer[3]="0";
    char Jourg[10]="";
    char Moisg[10]="";
    char Ang[10]="";

    if (Ar<1)
    {
      printf("date républicaine hors limite ligne %d \n",nbl);
      strcpy(Result,"");
      return;
    }
    
/* Calcul de la date gregorienne temporaire*/

    Ag=Ar+1792; 
    if ((Mr<4) || ((Mr==4) && (Jr<11)) || ((Mr==4) && (Jr==11) && (Ar%4!=0)))
    {
      Ag=Ag-1;
    }
    
    if (Mr==1)
    {
      if (Jr<10)
      {
        Mg=9;
        Jg=21+Jr;
      }
      else 
      {
        Mg=10;
        Jg=Jr-9;
      }
    }
    else if (Mr==2)
    {
      if (Jr<11)
      {
        Mg=10;
        Jg=Jr+21;
      }
      else
      {
        Mg=11;
        Jg=Jr-10;
      }
    }
    else if (Mr==3)
    {
      if (Jr<11)
      {
        Mg=11;
        Jg=Jr+20;
      }
      else 
      {
        Mg=12;
        Jg=Jr-10;
      }
    }
    else if (Mr==4)
    {
      if (Jr<11)
      {
        Mg=12;
        Jg=Jr+20;
      }
      else if (((Jr==11) && (Ar%4==0)) || (Jr>11))
      {
        Mg=1;
        Jg=Jr-11;
      }
      else if ((Jr==11) && (Ar%4!=0))
      {
        Mg=12;
        Jg=31;
      }  
    }
    else if (Mr==5)
    {
      if (Jr<13)
      {
        Mg=1;
        Jg=Jr+19;
      }
      else 
      {
        Mg=2;
        Jg=Jr-12;
      }
    }
    else if (Mr==6)
    {
      if (Jr<11)
      {
        Mg=2;
        Jg=Jr+18;
      }
      else 
      {
        Mg=3;
        Jg=Jr-10;
      }
    }
    else if (Mr==7)
    {
      if (Jr<12)
      {
        Mg=3;
        Jg=Jr+20;
      }
      else 
      {
        Mg=4;
        Jg=Jr-11;
      }
    }
     else if (Mr==8)
    {
      if (Jr<12)
      {
        Mg=4;
        Jg=Jr+19;
      }
      else 
      {
        Mg=5;
        Jg=Jr-11;
      }
    }
    else if (Mr==9)
    {
      if (Jr<13)
      {
        Mg=5;
        Jg=Jr+19;
      }
      else 
      {
        Mg=6;
        Jg=Jr-12;
      }
    }
    else if (Mr==10)
    {
      if (Jr<13)
      {
        Mg=6;
        Jg=Jr+18;
      }
      else 
      {
        Mg=7;
        Jg=Jr-12;
      }
    }
    else if (Mr==11)
    {
      if (Jr<14)
      {
        Mg=7;
        Jg=Jr+18;
      }
      else 
      {
        Mg=8;
        Jg=Jr-13;
      }
    }
    else if (Mr==12)
    {
      if (Jr<15)
      {
        Mg=8;
        Jg=Jr+17;
      }
      else 
      {
        Mg=9;
        Jg=Jr-14;
      }
    }
    else 
    {
      Mg=9;
      Jg=Jr+16;
    }
    
    Agt=Ag;
    Mgt=Mg;
    Jgt=Jg;
 
 /* premiere correction : annee republicaine multiple de 4 et jour compris entre
  le 1 Vendemiaire et le 10 Ventose inclus : ajouter un jour à la date gregorienne*/

    if ((Ar%4 ==0) && ((Mr<6) || ((Mr==6) && (Jr<11))))
    {
       Jg=Jg+1;
       if (((Mg==9) || (Mg==11))  && (Jg==31))
       {
         Mg=Mg+1;
         Jg=1;
       }
       else if (((Mg==10) || (Mg==12) || (Mg==1)) && (Jg==32))
       {
         Mg=(Mg+1)%12; 
         Jg=1;
       }
       else if ((Mg==2) && (Ag==1800) && (Mg==29))
       {
         Mg=3;
         Jg=1;
       }
    }
/* deuxieme correction*/
    if ((Ag >1800) || ((Ag==1800) && (Mgt>2)))
    {
      Jg=Jg+1;
    }
    
    if ((Jg==32) && ((Mg==1) || (Mg==3) || (Mg==5) || (Mg==7) || (Mg==8) || (Mg==10)))
    {
      Mg=Mg+1;
      Jg=1;      
    }
    else if (Jg==32)
    {
      Ag=Ag+1;
      Mg=1;
      Jg=1;
    }
    else if ((Jg==31) && ((Mg==4) || (Mg==6) || (Mg==9) || (Mg==11) ))
    {
      Mg=Mg+1;
      Jg=1;
    }
    else if ((Mg==2) && (Jg==29) && ((Ag%4 !=0) || (Ag==1800)))
    {
      Mg=Mg+1;
      Jg=1;
    }
    else if ((Mg==2) && (Jg==30) && (Ag%4==0) && (Ag !=1800))
    {
      Mg=Mg+1;
      Jg=1;
    }
    if (Ag>1805)
    {
      printf("date républicaine hors limite ligne %d, le résultat peut être erroné \n",nbl);
      strcpy(Result,"");
      return;
    }
    
    sprintf(Jourg,"%d",Jg);
    sprintf(Moisg,"%d",Mg);
    sprintf(Ang,"%d",Ag);
    
    
    if (strlen(Jourg)==1)
    {
      strcat(zer,Jourg);
      strcpy(Jourg,zer);
      strcpy(zer,"0");
    }
    else if (strlen(Jourg)!=2)
    {
        printf("Jour non Conforme ligne %d\n",nbl);
        strcpy(Result,"");
        return;
    }
    
    if (strlen(Moisg)==1)
    {
      strcat(zer,Moisg);
      strcpy(Moisg,zer);
      strcpy(zer,"0");
    }
    else if (strlen(Moisg)!=2)
    {
        printf("Mois non Conforme ligne %d \n",nbl);
        strcpy(Result,"");
        return;
    }
    
    if (strlen(Ang)!=4)
    {
        printf("Annee non Conforme lgne %d\n",nbl);
        strcpy(Result,"");
        return;
    }
    
    
    strcpy(Result,Jourg);
    strcat(Result,obl);
    strcat(Result,Moisg);
    strcat(Result,obl);
    strcat(Result,Ang);
    
}

int moisrtoi(char * moisRep)
{
    int nm;
    nm=0;
    
    if (strcmp(moisRep,"VEND")==0)
    {
      nm=1;
    }
    else if (strcmp(moisRep,"BRUM")==0)
    {
      nm=2;   
    }
    else if (strcmp(moisRep,"FRIM")==0)
    {
      nm=3;   
    }
    else if (strcmp(moisRep,"NIVO")==0)
    {
      nm=4;   
    }
    else if (strcmp(moisRep,"PLUV")==0)
    {
      nm=5;   
    }
    else if (strcmp(moisRep,"VENT")==0)
    {
      nm=6;   
    }
    else if (strcmp(moisRep,"GERM")==0)
    {
      nm=7;   
    }
    else if (strcmp(moisRep,"FLOR")==0)
    {
      nm=8;   
    }
    else if (strcmp(moisRep,"PRAI")==0)
    {
      nm=9;   
    }
     else if (strcmp(moisRep,"MESS")==0)
    {
      nm=10;   
    }
    else if (strcmp(moisRep,"THER")==0)
    {
      nm=11;   
    }
    else if (strcmp(moisRep,"FRUC")==0)
    {
      nm=12;   
    }
    else if (strcmp(moisRep,"COMP")==0)
    {
      nm=13;   
    }
    else
    {
    /*printf("mois republicain inconnu ligne %d \n",nbl);*/
     nm=0;
    }
  return nm;
}
    
    

int main(int argc, char *argv[])


{
    FILE* f=NULL;
    FILE* g=NULL;
    char extension[6]=".Greg";
    char tampon[20]="";
    char jourRep[5]="";
    int jr;
    char moisRep[10]="";
    char anRep[5]="";
    int nbl=0;
    int mr;
    int ar;
    int ag;
    int jg;
    int mg;
    char result[15];
    char* nom1;
    char* nom2;
    int err=0;
    
  nom1=argv[1];
  nom2=malloc(500);
  strcpy(nom2,nom1);
  strcat(nom2,extension);
  
  if ((f=fopen(nom1,"r"))== NULL)
  {
    printf("Le fichier source est inexistant\n");
    return 2;
  }
  if ((g=fopen(nom2,"w"))==NULL)
  {
    printf("Le fichier image ne peut etre ecrit\n");
    return 3;
  }
  while ( fgets ( tampon, 15, f ) != NULL )
  {
     err=0;
     nbl=nbl+1;
     if (strlen(tampon)>11)
     {
       printf("format date errone ligne %d\n",nbl);
       strcpy(result,"");
       err=9;
     }
     if (strlen(tampon)<2)
     {
       strcpy(result,"");
       printf("ligne %d vide\n",nbl);
       err=1;
     }
     if (err==0)
     {
     if (strlen(tampon)<11)
     {
       printf("format date errone ligne %d\n",nbl);
       strcpy(result,"");
       err=9;
     }
     }
     if (err==0)
     {
     jourRep[0]=tampon[0];
     jourRep[1]=tampon[1];
     jourRep[2]='\0';
     
     if (tampon[2] !='/')
     {
         printf("erreur de format ligne %d\n",nbl);
         strcpy(result,"");
         err=1;
     }
     if (err==0)
     {
     jr=atoi(jourRep);
     if ((jr>30)||(jr<1))
     {
       printf("Jour hors limites ligne %d \n",nbl);
       strcpy(result,"");
       err=2;
     }
     }
     if (err==0)
     {
     moisRep[0]=tampon[3];
     moisRep[1]=tampon[4];
     moisRep[2]=tampon[5];
     moisRep[3]=tampon[6];
     moisRep[4]='\0';
     
     if (tampon[7]!='/')
     {
         printf("erreur de format ligne %d\n",nbl);
         strcpy(result,"");
         err=3;
     }
     }
     if (err==0)
     {
     mr=moisrtoi(moisRep);
     if (mr==0)
     {
       printf("mois republicain inconnu ligne %d \n",nbl);
       strcpy(result,"");
       err=10;
     }
     if ((mr==13) && (jr>6))
     {
       printf("jour complementaire inconnu ligne %d\n",nbl);
       strcpy(result,"");
       err=8;
     }
     }
     
     anRep[0]=tampon[8];
     anRep[1]=tampon[9];
     anRep[2]='\0';
     ar=atoi(anRep);
     if (err==0)
     {
     if (ar==0)
     {
        printf("annee mal ecrite ligne %d\n", nbl);
        strcpy(result,"");
        err=4;
     }
     }
     if (err==0)
     {
     if ((mr==13) && (jr==6) && (ar !=3) && (ar !=7) && (ar !=11))
     {
       printf("Annee non sextile, jour hors limite ligne %d\n",nbl);
       strcpy(result,"");
       err=8;
     }
     }
     if (err==0)
     {
     traduc(result,jr,mr,ar,nbl);
     }
     }
     fprintf(g,"%s\n",result);
  }
  fclose(f);
  fclose(g);
}


