

/***************************************************/
/***************************************************/
/*****                                         *****/
/*****        Logiciel  R2G version V2         *****/
/*****                                         *****/
/*****      fichier source en langage c        *****/
/*****   Auteur Cruptos (association ACrypTA)  *****/
/*****   date : 15/05/2021                     *****/
/*****                                         *****/
/***************************************************/
/***************************************************/
/**modifié le 15/05/2021 pour détecter les lignes vides**/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int moisrtoi(char * moisRep)
{
    int nm;
    nm=0;
    
    if (strcmp(moisRep,"VEND")==0)
    {
      nm=1;
    }
    else if (strcmp(moisRep,"BRUM")==0)
    {
      nm=2;   
    }
    else if (strcmp(moisRep,"FRIM")==0)
    {
      nm=3;   
    }
    else if (strcmp(moisRep,"NIVO")==0)
    {
      nm=4;   
    }
    else if (strcmp(moisRep,"PLUV")==0)
    {
      nm=5;   
    }
    else if (strcmp(moisRep,"VENT")==0)
    {
      nm=6;   
    }
    else if (strcmp(moisRep,"GERM")==0)
    {
      nm=7;   
    }
    else if (strcmp(moisRep,"FLOR")==0)
    {
      nm=8;   
    }
    else if (strcmp(moisRep,"PRAI")==0)
    {
      nm=9;   
    }
     else if (strcmp(moisRep,"MESS")==0)
    {
      nm=10;   
    }
    else if (strcmp(moisRep,"THER")==0)
    {
      nm=11;   
    }
    else if (strcmp(moisRep,"FRUC")==0)
    {
      nm=12;   
    }
    else if (strcmp(moisRep,"COMP")==0)
    {
      nm=13;   
    }
    else
    {
        nm=0;
    }
  return nm;
}
    
    
int main(int argc, char *argv[])


{
    FILE* f=NULL;
    char tampon[20]="";
    char jourRep[5]="";
    int jr;
    char moisRep[10]="";
    char anRep[5]="";
    int nbl=0;
    int mr;
    int ar;
    char* nom1;
    int err;
    
    
  nom1=argv[1];
 
  if ((f=fopen(nom1,"r"))== NULL)
  {
    printf("Le fichier source est inexistant\n");
    return 2;
  }
  while ( fgets ( tampon, 15, f ) != NULL )
  {
     err=0;
     nbl=nbl+1;
     if (strlen(tampon)>11)
     {
       printf("format date errone ligne %d\n",nbl);
       err=1;
     }
     if (strlen(tampon)<2)
     {
       printf("ligne vide %d\n",nbl);
       err=1;
     }
    if (err==0)
    {
     jourRep[0]=tampon[0];
     jourRep[1]=tampon[1];
     jourRep[2]='\0';
     jr=atoi(jourRep);
     
     if (tampon[2] !='/')
     {
         printf("erreur de format ligne %d\n",nbl);
         err=1;
     }
    }
    if (err==0)
    {
     if ((jr>30)||(jr<1))
     {
       printf("Jour hors limites ligne %d \n",nbl);
       err=1; 
     }
    }
    if (err==0)
    {
     moisRep[0]=tampon[3];
     moisRep[1]=tampon[4];
     moisRep[2]=tampon[5];
     moisRep[3]=tampon[6];
     moisRep[4]='\0';
     mr=moisrtoi(moisRep);
    if (mr==0)
    {
       printf("mois républicain inconnu ligne %d\n",nbl); 
       err=1;
    }
    }
    if (err==0)
    {
     if (tampon[7]!='/')
     {
         printf("erreur de format ligne %d\n",nbl);
         err=1;
     }
    } 
    if (err==0)
    {
     if ((mr==13) && (jr>6))
     {
       printf("jour complementaire inconnu ligne %d\n",nbl);
       err=1;
     }
    }
    if (err==0)
    {
     anRep[0]=tampon[8];
     anRep[1]=tampon[9];
     anRep[2]='\0';
     ar=atoi(anRep);
     
     if (ar==0)
     {
        printf("annee mal ecrite ligne %d\n", nbl);
        err=1;
     }
    }
    if (err==0)
    {
      if (((ar <0) || (ar> 14)) || ((ar==14) && ((mr>4) || ((mr==4) && (jr>11)))))
      {
        printf("annee hors limite ligne %d\n", nbl);
        err=1;  
      }
    }
    if (err==0)
    {
     if ((mr==13) && (jr==6) && (ar !=3) && (ar !=7) && (ar !=11))
     {
       printf("Annee non sextile, jour hors limite ligne %d\n",nbl);
       err=1;
     }
    }
  }
  fclose(f);
  printf("fini \n");
}


